/* WCEOffscreenImage.java
   Copyright (C) 2009 Free Software Foundation, Inc.

This file is part of GNU Classpath.

GNU Classpath is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

GNU Classpath is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Classpath; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */

package gnu.java.awt.peer.wce;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.ImageCapabilities;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.awt.image.ImageProducer;
import java.awt.image.VolatileImage;

public class WCEVolatileImage extends VolatileImage
{
  private static final ImageCapabilities CAPABILITIES = new Capabilities();

  private final WCEOffscreenImage offscreenImage;

  private static class Capabilities extends ImageCapabilities
  {
    public Capabilities()
    {
      super(false);
    }

    public boolean isTrueVolatile()
    {
      return false;
    }
  };
  
  public WCEVolatileImage(WCEOffscreenImage offscreenImage)
  {
//    System.err.println("WCEVolatileImage() created");
//    Exception ex = new Exception();
//    ex.printStackTrace();
    this.offscreenImage = offscreenImage;
  }

  protected WCEOffscreenImage getWCEOffscreenImage()
  {
    return this.offscreenImage;
  }

  public BufferedImage getSnapshot()
  {
    throw new UnsupportedOperationException();
  }

  public int getWidth()
  {
    return offscreenImage.getWidth();
  }

  public int getHeight()
  {
    return offscreenImage.getHeight();
  }

  public ImageProducer getSource()
  {
    return offscreenImage.getSource();
  }

  public Graphics getGraphics()
  {
    return createGraphics();
  }

  public Graphics2D createGraphics()
  {
    return new WCEGraphics2D(this.offscreenImage);
  }

  public int validate(GraphicsConfiguration gc)
  {
    return VolatileImage.IMAGE_OK;
  }

  public boolean contentsLost()
  {
    return false;
  }

  public ImageCapabilities getCapabilities()
  {
    return CAPABILITIES;
  }

  public void flush()
  {
    offscreenImage.flush();
  }

  public int getWidth(ImageObserver observer)
  {
    return getWidth();
  }

  public int getHeight(ImageObserver observer)
  {
    return getHeight();
  }

  public Object getProperty(String name, ImageObserver observer)
  {
    return offscreenImage.getProperty(name, observer);
  }
}